Eo's Event Handling

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Macros | Functions
Eo's Event Handling
EoEo » | Eo's Base class.

## Macros
#define | EO_EVENT_DESCRIPTION(name) { name, EINA_FALSE, EINA_FALSE }
| An helper macro to help populating Eo_Event_Description. More...
#define | EO_EVENT_DESCRIPTION_HOT(name) { name, EINA_TRUE, EINA_FALSE }
| An helper macro to help populating Eo_Event_Description and make the event impossible to freeze. More...
#define | EO_CALLBACK_PRIORITY_BEFORE -100
| Slightly more prioritized than default.
#define | EO_CALLBACK_PRIORITY_DEFAULT 0
| Default callback priority level.
#define | EO_CALLBACK_PRIORITY_AFTER 100
| Slightly less prioritized than default.
#define | EO_CALLBACK_STOP EINA_FALSE
| Stop calling callbacks for the even of which the callback was called for. More...
#define | EO_CALLBACK_CONTINUE EINA_TRUE
| Continue calling callbacks for the even of which the callback was called for. More...
#define | EO_CALLBACKS_ARRAY_DEFINE(Name, ...)
| Helper for creating global callback arrays. More...
#define | eo_event_callback_add(desc, cb, data)
| Add a callback for an event. More...
#define | eo_event_callback_array_add(array, data)
| Add a callback array for an event. More...

## Functions
EAPI const Eo_Event_Description * | eo_base_legacy_only_event_description_get (const char *_event_name)
| Don't use. More...

## Detailed Description

## Macro Definition Documentation

#define EO_EVENT_DESCRIPTION | ( |  | name | ) | { name, EINA_FALSE, EINA_FALSE }

An helper macro to help populating Eo_Event_Description.

Parameters

  name | The name of the event.

See also
  Eo_Event_Description

#define EO_EVENT_DESCRIPTION_HOT | ( |  | name | ) | { name, EINA_TRUE, EINA_FALSE }

An helper macro to help populating Eo_Event_Description and make the event impossible to freeze.

Parameters

  name | The name of the event.

See also
  Eo_Event_Description
  EO_EVENT_DESCRIPTION

#define EO_CALLBACK_STOP EINA_FALSE

Stop calling callbacks for the even of which the callback was called for.

See also
  EO_CALLBACK_CONTINUE

Referenced by ecore_con_url_pipeline_get().

#define EO_CALLBACK_CONTINUE EINA_TRUE

Continue calling callbacks for the even of which the callback was called for.

See also
  EO_CALLBACK_STOP

Referenced by ecore_con_url_pipeline_get().

#define EO_CALLBACKS_ARRAY_DEFINE | ( |  | Name,
|  |  | ...
| ) |  |

Value:
static Eo_Callback_Array_Item * \
Name(void) \
{ \
static Eo_Callback_Array_Item internal[sizeof ((Eo_Callback_Array_Item[]) { __VA_ARGS__ }) / \
sizeof (Eo_Callback_Array_Item) + \
1] = { { 0, 0 } }; \
if (internal[0].desc == NULL) \
{ \
memcpy(internal, \
((Eo_Callback_Array_Item[]) { __VA_ARGS__, { NULL, NULL } }), \
sizeof (Eo_Callback_Array_Item) + \
sizeof ((Eo_Callback_Array_Item[]) { __VA_ARGS__ })); \
} \
return internal; \
}
_Eo_Callback_Array_Item
An item in an array of callback desc/func.
Definition: eo_base.eo.h:32

Helper for creating global callback arrays.

The problem is on windows where you can't declare a static array with external symbols in it, because the addresses are only known at runtime.

Referenced by ecore_con_url_pipeline_get().

#define eo_event_callback_add | ( |  | desc,
|  |  | cb,
|  |  | data
| ) |  |

Value:
eo_event_callback_priority_add(desc, \
EO_CALLBACK_PRIORITY_DEFAULT, cb, data)
EO_CALLBACK_PRIORITY_DEFAULT
#define EO_CALLBACK_PRIORITY_DEFAULT
Default callback priority level.
Definition: Eo.h:951

Add a callback for an event.

Parameters

  [in] | desc | The description of the event to listen to.
  [in] | cb | the callback to call.
  [in] | data | additional data to pass to the callback.

callbacks of the same priority are called in reverse order of creation.

See also
  eo_event_callback_priority_add()

Examples:
  emotion_basic_example.c, and emotion_signals_example.c.

Referenced by edje_audio_channel_mute_get(), eo_base_legacy_only_event_description_get(), and evas_textblock_text_utf8_to_markup().

#define eo_event_callback_array_add | ( |  | array,
|  |  | data
| ) |  |

Value:
eo_event_callback_array_priority_add(array, \
EO_CALLBACK_PRIORITY_DEFAULT, data)
EO_CALLBACK_PRIORITY_DEFAULT
#define EO_CALLBACK_PRIORITY_DEFAULT
Default callback priority level.
Definition: Eo.h:951

Add a callback array for an event.

Parameters

  [in] | array | an Eo_Callback_Array_Item of events to listen to.
  [in] | data | additional data to pass to the callback.

callbacks of the same priority are called in reverse order of creation.

See also
  eo_event_callback_array_priority_add()

Referenced by ecore_con_url_new().

## Function Documentation

EAPI const Eo_Event_Description* eo_base_legacy_only_event_description_get | ( | const char * | _event_name | ) |

Don't use.

The values of the returned event structure are also internal, don't assume anything about them.

References DBG, EINA_FALSE, eina_hash_add(), eina_hash_find(), EINA_LIST_FOREACH, eina_list_prepend(), eina_list_remove(), eina_stringshare_add(), eina_stringshare_del(), EINA_TRUE, EINA_UNLIKELY, eo_event_callback_add, eo_isa(), ERR, _Eo_Callback_Array_Item::func, _Eo_Event_Description::legacy_is, efl::eo::parent, and _Eo_Event_Description::unfreezable.

Referenced by evas_object_smart_callback_call(), evas_object_smart_callback_del(), evas_object_smart_callback_del_full(), and evas_object_smart_callback_priority_add().